<?php
/****************************************************************************\
* TaskFreak!                                                                 *
* single user                                                                *
******************************************************************************
* Version: 0.5                                                               *
* Release date: 2 january 2006                                               *
* Authors: Stan Ozier <stan@tirzen.net>                                      *
* License:  http://www.gnu.org/licenses/gpl.txt (GPL)                        *
******************************************************************************
* This file is part of "TaskFreak! single user" program.                     *
*                                                                            *
* TaskFreak! single user is free software; you can redistribute it and/or    *
* modify it under the terms of the GNU General Public License as published   *
* by the Free Software Foundation; either version 2 of the License, or (at   *
* your option) any later version.                                            *
*                                                                            *
* TaskFreak! single user is distributed in the hope that it will be          *
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
* GNU General Public License for more details.                               *
*                                                                            *
* You should have received a copy of the GNU General Public License          *
* along with this program; if not, write to the Free Software                *
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA *
\****************************************************************************/

include 'config.php';
include PRJ_ROOT_PATH.'language/lg_'.FRK_LANGUAGE.'.php';
include PRJ_CLASS_PATH.'tzn_generic.php';
include PRJ_CLASS_PATH.TZN_DB_CLASS;
include PRJ_CLASS_PATH.'pkg_freak.php';

if (defined('FRK_CHARSET')) {
    header('Content-type: text/html;charset='.FRK_CHARSET);
}

$objEditItem = new Task();
if ($_REQUEST['id']) {
	$objEditItem->setUid($_REQUEST['id']);
	$objEditItem->load();
	if ($_REQUEST['mode'] && $_REQUEST['mode'] != 'save') {
		switch($_REQUEST['mode']) {
			case 'delete':
				$objEditItem->delete();
				$pMessage = $arrLanguageMessage['done_deleted'];
				break;
			default:
				$objEditItem->set('status',$_REQUEST['mode']);
				$objEditItem->update('status');
				$pMessage = $arrLanguageMessage['done_status'];
		}
		$objEditItem = new Task();
	}
}

// --- NEW / UPDATE TASK ----------------------------------------
if ($_REQUEST['mode'] == 'save') {
	$objEditItem->setAuto($_POST);
	if ($_REQUEST['project2']) {
		$objEditItem->setHttp('project',$_POST['project2']);
	}
	$status = 0;
	for ($i=1; $i<=FRK_STATUS_LEVELS; $i++) {
		$j = 'status'.$i;
		if ($_POST[$j] != 1) {
			break;
		}
		$status++;
	}
	$objEditItem->set('status',$status);
	if ($objEditItem->check()) {
		if ($objEditItem->isLoaded()) {
    		$objEditItem->update();
    		$pMessage = $arrLanguageMessage['done_updated'];
    	} else {
    		$objEditItem->add();
    		$pMessage = $arrLanguageMessage['done_added'];
    	}
		$objEditItem = new Task();
	}
}

// --- LOAD TASKS -----------------------------------------------
$objItemList = new Task();
if ($_REQUEST['sProject']) {
	$pProject = (get_magic_quotes_gpc())?
		stripslashes($_REQUEST['sProject']):$_REQUEST['sProject'];
	$objItemList->addWhere('project = \''.addslashes($pProject).'\'');
}
if ($_REQUEST['sContext']) {
	$pContext = $_REQUEST['sContext'];
	$objItemList->addWhere('context = \''.$pContext.'\'');
}
$sqlFilter = '';
$pShow = ($_REQUEST['show'])?$_REQUEST['show']:'today';

$pKeepNoDead = intval(@constant('FRK_NO_DEADLINE_KEEP') -1) * 86400;

if (@constant('FRK_NO_DEADLINE_TOO')) {
	$sqlToday = ' OR (deadlineDate = \'9999-00-00\' AND (status < '.FRK_STATUS_LEVELS
	   .' OR (status = '.FRK_STATUS_LEVELS.' AND lastChangeDate > \''
	   .gmdate('Y-m-d 00:00:00',time()-$pKeepNoDead).'\')))';
	$sqlFuture = ' AND deadlineDate <> \'9999-00-00\'';
} else {
	$sqlFuture = ' OR (deadlineDate = \'9999-00-00\' AND status < '
	   .FRK_STATUS_LEVELS.')';
	$sqlToday = ' AND deadlineDate <> \'9999-00-00\'';
}

switch ($pShow) {
	case 'all':
		break;
	case 'future':
		// show coming tasks and late tasks (undone only)
		$sqlFilter = '((deadlineDate >= \''
			.strftime(TZN_DATE_SQL,PRJ_DTE_NOW).'\' AND status < '
			.FRK_STATUS_LEVELS.')'.' OR status < '.FRK_STATUS_LEVELS.')'
			.$sqlFuture;
		break;
	case 'past':
		// show past tasks and already done
		$sqlFilter = '(deadlineDate <= \''
			.strftime(TZN_DATE_SQL,PRJ_DTE_NOW).'\' OR status = '
			.FRK_STATUS_LEVELS.')';
		break;
	case 'today':
		// show all future tasks (done + undone) and late tasks
		$sqlFilter = '(((deadlineDate >= \''
			.strftime(TZN_DATE_SQL,PRJ_DTE_NOW).'\' AND deadlineDate <> '
			.'\'9999-00-00\') OR status < '
			.FRK_STATUS_LEVELS.') '.$sqlToday.')';
		break;
	default:
		break;
}

if ($sqlFilter) {
	$objItemList->addWhere('('.$sqlFilter.')');
}

// --- ordering statement ---
$pSort = ($_REQUEST['sort'])?$_REQUEST['sort']:
	((defined('FRK_SORT_COLUMN'))?FRK_SORT_COLUMN:'deadlineDate');
$pDir = ($_REQUEST['dir'])?$_REQUEST['dir']:
	((defined('FRK_SORT_ORDER'))?FRK_SORT_ORDER:1);
$objItemList->setOrder($pSort,$pDir);

// load
$objItemList->loadList();

// --- LOAD PROJECTS --------------------------------------------
$objProjectList = new Project();
$objProjectList->addWhere("project <> ''");
$objProjectList->loadList();


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="content-type" content="text/html; charset=<?php echo (defined('FRK_CHARSET'))?FRK_CHARSET:'ISO-8859-1'; ?>" />
    <title>TaskFreak!</title>
    <link href="freak.css" rel="stylesheet" type="text/css" />
	<!--[if gte IE 5.5]>
	<![if lt IE 7]>
	<style type="text/css">
	div#header {
		position: absolute;
		left: expression( ( 0 + ( ignoreMe2 = document.documentElement.scrollLeft ? document.documentElement.scrollLeft : document.body.scrollLeft ) ) + 'px' );
		top: expression( ( 0 + ( ignoreMe = document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop ) ) + 'px' );
	}
	</style>
	<![endif]>
	<![endif]-->
	<link href="priority<?php echo FRK_PRIORITY_LEVELS; ?>.css" rel="stylesheet" type="text/css" />
	<link href="context.css" rel="stylesheet" type="text/css" />
	<style type="text/css">
	<?php if (@constant('FRK_CONTEXT_LONG')) { ?>
	table.sheet td.ctxt {
		font-size: x-small;
	}
	<?php } else { ?>
	table.sheet td.ctxt {
		text-align: center;
	}
	table.sheet td.ctxt span, #vctxt span {
		font-family: "Courier New", Courier, monospace;
		font-size: 10px;
		color: #fff;
		text-align: center;
		padding: 2px 4px 1px 4px;
		width: 14px;
	}
	<?php } ?>
	</style>
	<script type="text/javascript" language="JavaScript" src="cpaint/cpaint2.inc.compressed.js"></script>
	<script type="text/javascript" language="JavaScript" src="freak.js"></script>
	<script>
		function freak_calc(sts) {
			f = document.getElementById('vsts');
			f.innerHTML = (Math.round((sts * 100) / <?php echo FRK_STATUS_LEVELS; ?>))+'% completed';
		}
	</script>
	<style type="text/css">@import url(jscalendar/calendar-freak.css);</style>
    <script type="text/javascript" src="jscalendar/calendar.js"></script>
    <script type="text/javascript" src="jscalendar/lang/calendar-en.js"></script>
    <script type="text/javascript" src="jscalendar/calendar-setup.js"></script>
	<link rel="alternate" type="application/rss+xml" title="RSS Feed" href="rss.php" />
</head>
<body onmousedown="listenClick(event);"<?php
	if ($rId = intval($_REQUEST['rssId'])) {
?> onload="freak_init(); freak_view(<?php echo $rId; ?>)" <?php
	}
?>>
  <form name="zappa" action="index.php" method="POST" id="zappa">
	<input type="hidden" name="sProject" value="<?php echo $pProject; ?>" />
	<input type="hidden" name="id" value="<?php echo $objEditItem->id; ?>" />
	<input type="hidden" name="show" value="<?php echo $pShow; ?>" />
	<input type="hidden" name="sort" value="<?php echo $pSort; ?>" />
	<input type="hidden" name="dir" value="<?php echo $pDir; ?>" />
	<?php
		if (@constant('FRK_CONTEXT_ENABLE')) {
	?>
	<input type="hidden" name="sContext" value="<?php echo $pContext; ?>" />
	<?php
		}
	?>
	<input type="hidden" name="mode" value="save" />
    <div id="header">
      <div id="header2">
<?php
// -------------- NAV MENU ---------------------------------------------------
?>
    	<div id="menu">
          <ul id="nav" class="level0">
            <li><?php echo $arrLanguageMenu['task']; ?>
              <ul class="level1">
                <li><a href="javascript:freak_new()" accesskey="n"><?php echo $arrLanguageMenu['new_todo']; ?></a></li>
              </ul>
            </li>
            <li><?php echo $arrLanguageMenu['view']; ?>
              <ul class="level1">
                <li><a href="?" accesskey="l"><?php echo $arrLanguageMenu['all_projects']; ?></a>
                  <ul>
                    <li><a href="?show=future" accesskey="f"><?php echo $arrLanguageMenu['future_tasks']; ?></a></li>
                    <li><a href="?show=past" accesskey="p"><?php echo $arrLanguageMenu['past_tasks']; ?></a></li>
                    <li><a href="?show=all" accesskey="a"><?php echo $arrLanguageMenu['all_tasks']; ?></a></li>
                  </ul>
                </li>
              <?php
             	while ($objProj = $objProjectList->rNext()) {
             		$pLink = 'index.php?sProject='.urlencode($objProj->project);
              ?>
                <li class="more"><a href="<?php echo $pLink; ?>"><?php $objProj->p('project'); ?></a>
                  <ul class="level2">
                    <li><a href="<?php echo Tzn::concatUrl($pLink,'show=future')?>"><?php echo $arrLanguageMenu['future_tasks']; ?></a></li>
                    <li><a href="<?php echo Tzn::concatUrl($pLink,'show=past')?>"><?php echo $arrLanguageMenu['past_tasks']; ?></a></li>
                    <li><a href="<?php echo Tzn::concatUrl($pLink,'show=all')?>"><?php echo $arrLanguageMenu['all_tasks']; ?></a></li>
                  </ul>
                </li>
              <?php
              	}
				if (@constant('FRK_CONTEXT_ENABLE')) {
					$pLink = 'index.php?sProject='.urlencode($pProject).'&show='.$pShow;
				?>
				<li><a href="?"><?php echo $arrLanguageMenu['all_contexts']; ?></a>
				  <ul>
				    <?php foreach($_GLOBALS['arrContexts'] as $key => $value) { ?>
					<li><a href="<?php echo Tzn::concatUrl($pLink,'sContext='.$key)?>"><?php echo $value; ?></a></li>
					<?php } ?>
				  </ul>
				</li>
				<?php
				}
				?>
                <li><a href="javascript:freak_rld()" accesskey="r"><?php echo $arrLanguageMenu['reload']; ?></a></li>
              </ul>
            </li>
            <li><?php echo $arrLanguageMenu['manage']; ?>
              <ul class="level1">
                <li><a href="project.php" target="freak2" onClick="freak_pop('freak2',400,400)"><?php echo $arrLanguageMenu['projects']; ?></a></li>
              </ul>
            </li>
          </ul>
        </div>
        <div id="logo">
          <img src="images/logostill.png" width="148" height="24" border="0" alt="task freak! (logo)" />
        </div>
      </div>
      <?php

// ------------ ERROR / INFO MESSAGE -------------------------------------

		if ($pMessage) {
			echo '<div id="message">'.$pMessage.'</div>';
		}

// ------------- EDIT FORM ------------------------------------------------	  
	  ?>
      <div id="fedit" style="display:none">
    	<table cellpadding="2" cellspacing="0" border="0">
    	  <tr>
    	    <th><?php echo $arrLanguageForm['priority']; ?>:</th>
    	    <td><input type="text" name="priority" class="prio" value="3" /></td>
		<?php
			if (@constant('FRK_CONTEXT_ENABLE')) {
		?>
			<th><?php echo $arrLanguageForm['context']; ?>:</td>
			<td><select name="context">
			  <?php foreach($_GLOBALS['arrContexts'] as $key => $value) { ?>
			  <option value="<?php echo $key; ?>"><?php echo $value; ?></option>
			  <?php } ?>
			</select></td>
		  </tr>
		  <tr>
		<?php
			}
		?>
    	    <th><?php echo $arrLanguageForm['deadline']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>>
    	      <input type="text" name="deadlineDate" class="dead" id="freak_cal_d" />
              <img src="images/cal.gif" id="freak_cal_b" style="cursor: pointer;" title="Date selector" />
              <span class="discrete"><?php echo $arrLanguageDate['help']; ?></span>
            </td>
    	  </tr>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['project']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>>
			<span id="project_sel" style="display:block"><?php
				$objProjectList->rReset();
				$objProjectList->qSelect('project','project',$pProject,'- - - - - - - - -','style="width:200px"'); 
			?> <a href="javascript:freak_switch('project')" class="small">&gt; <?php echo $arrLanguageForm['project_new']; ?></a>
			</span>
			<span id="project_txt" style="display:none"><input type="text" name="project2" value="" style="width:200px"/>
			  <a href="javascript:freak_switch('project')" class="small">&lt; <?php echo $arrLanguageForm['project_list']; ?></a>
			</td>
    	  </tr>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['title']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><input type="text" name="title" class="full" /></td>
    	  </tr>
		  <?php if (@constant('FRK_DESCRIPTION_ENABLE')) { ?>
    	  <tr valign="top">
    	    <th><?php echo $arrLanguageForm['description']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><textarea name="description" class="full">loading...</textarea></td>
    	  </tr>
		  <?php } ?>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['status']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>>
    	      <?php
					for ($i = 1; $i <= FRK_STATUS_LEVELS; $i++) {
						echo '<input name="status'.$i.'" type="checkbox" value="1" onclick="freak_adj('.$i.')" class="fff" />';
						echo "\n";
					}
				?>
    	    </td>
    	  </tr>
    	</table>
    	<p>
    	  <input type="image" src="images/sav.png" width="49" height="20" border="0" alt="<?php echo $arrLanguageForm['save']; ?>" onClick="return freak_sav()"/>
    	  &nbsp; &nbsp;
    	  <a href="javascript:freak_edit(0)"><img src="images/clx.png" width="49" height="20" border="0" alt="<?php echo $arrLanguageForm['cancel']; ?>" /></a>
    	</p>
      </div>
<?php
// -------------- VIEW PANEL --------------------------------------------------
?>
	  <div id="fview" style="display:none">
		<table cellpadding="2" cellspacing="0" border="0">
    	  <tr>
    	    <th><?php echo $arrLanguageForm['priority']; ?>:</th>
    	    <td><div id="vprio"></div></td>
		<?php
			if (@constant('FRK_CONTEXT_ENABLE')) {
		?>
			<th width="15%" style="text-align:right"><?php echo $arrLanguageForm['context']; ?>:</td>
			<td width="60%"><div id="vctxt"></div></td>
		  </tr>
		  <tr>
		<?php
			}
		?>
    	    <th><?php echo $arrLanguageForm['deadline']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><div id="vdead"></div></td>
    	  </tr>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['project']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><div id="vproj"></div></td>
    	  </tr>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['title']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><div id="vtitl"></div></td>
    	  </tr>
		  <?php if (@constant('FRK_DESCRIPTION_ENABLE')) { ?>
    	  <tr valign="top">
    	    <th><?php echo $arrLanguageForm['description']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><div id="vdesc"></div></td>
    	  </tr>
		  <?php } ?>
    	  <tr>
    	    <th><?php echo $arrLanguageForm['status']; ?>:</th>
    	    <td<?php echo (@constant('FRK_CONTEXT_ENABLE'))?' colspan="3"':''; ?>><div id="vsts"></div></td>
    	  </tr>
    	</table>
		<p><a href="javascript:freak_view(0)"><img src="images/clx.png" width="49" height="20" border="0" alt="<?php echo $arrLanguageForm['cancel']; ?>" /></a></p>
	  </div>
    </div>
<?php
// -------------- TASK LIST (HEADER) ------------------------------------------
?>
    <div id="container">
		<div id="content">
			<table cellpadding="2" cellspacing="1" border="0" class="sheet" width="100%">
				<thead>
					<tr>
						<th width="4%" onclick="freak_sort('priority')">&nbsp;</th>
						<?php
							$titleWidth = 0;
							$titleLabel = '&nbsp;';
							if (@constant('FRK_CONTEXT_ENABLE')) {
								if (@constant('FRK_CONTEXT_LONG')) {
									$titleWidth = 10;
									$titleLabel = $GLOBALS['arrLanguageForm']['context'];
								} else {
									$titleWidth = 4;
								}
						?>
						<th width="<?php echo $titleWidth; ?>%" onclick="freak_sort('context')"><?php echo $titleLabel; ?></th>
						<?php
							}

						?>
						<th width="<?php echo 26-(FRK_STATUS_LEVELS * 2) ?>%" onclick="freak_sort('project')"><?php echo $arrLanguageForm['project']; ?></th>
						<th width="<?php echo 55-$titleWidth; ?>%" onclick="freak_sort('title')"><?php echo $arrLanguageForm['title']; ?></th>
						<th width="10%" onclick="freak_sort('deadline')"><?php echo $arrLanguageForm['deadline']; ?></th>
						<th width="<?php echo FRK_STATUS_LEVELS * 2; ?>%" onclick="freak_sort('status')" colspan="<?php echo FRK_STATUS_LEVELS ?>"><?php echo (FRK_STATUS_LEVELS == 1)?'X':$arrLanguageForm['status']; ?></th>
						<th width="5%" class="act"><a href="javascript:freak_new()"><img src="images/new.png" width="39" height="16" border="0" hspace="3" alt="<?php echo $arrLanguageForm['new']; ?>" /></a></th>
					</tr>
				</thead>
				<tbody>
	<?php

// ----------- TASK LIST (CONTENT) -------------------------------------------

	if ($objItemList->rMore()) {
		while ($objItem = $objItemList->rNext()) {
			$priority = $objItem->priority;
	?>
					<tr id="<?php echo $objItem->id; ?>">
						<td id="eprio<?php echo $objItem->id; ?>" class="prio"><span class="pr<?php echo $priority; ?>" title="<?php echo $_GLOBALS['arrPriorities'][$objItem->priority]; ?>"><?php echo $priority; ?></span></td>
					<?php
                        if (@constant('FRK_CONTEXT_ENABLE')) {
					?>
						<td id="ectxt<?php echo $objItem->id; ?>" class="ctxt"><?php
                            if (@constant('FRK_CONTEXT_LONG')) {
					?><span class="small"><?php echo $_GLOBALS['arrContexts'][$objItem->context]; ?></span><?php
						    } else {
					?><span class="ct<?php echo $objItem->context; ?>" title="<?php echo $_GLOBALS['arrContexts'][$objItem->context]; ?>"><?php echo $objItem->context; ?></span><?php
    			            }
					?></td>
						<?php
                        }
					?>
						<td id="eproj<?php echo $objItem->id; ?>"><?php echo $objItem->p('project','-'); ?></td>
						<td id="etitl<?php echo $objItem->id; ?>"><?php 
							echo $objItem->p('title'); 
							if ($objItem->description) {
								echo '<img src="images/desc.png" width="16" height="16" align="absmiddle" border="0" />';
							}
						?></td>
						<td id="edead<?php echo $objItem->id; ?>"><?php echo $objItem->pDeadline(); ?></td>
					<?php
						$s = $objItem->status;
						for ($i = 0; $i < FRK_STATUS_LEVELS; $i++) {
							$j = ($i < $s)?(FRK_STATUS_LEVELS - $i):0;
					?>
						<td id="est<?php echo ($i+1).$objItem->id; ?>" class="sts<?php echo $j; ?>" onclick="freak_sts(<?php echo $objItem->id; ?>,<?php echo $i+1; ?>)">&nbsp;</td>
					<?php
						}
					?>
						<td class="act"><a href="javascript:freak_edit(<?php echo $objItem->id; ?>)" title="<?php echo $GLOBALS['arrLanguageMessage']['task_edit']; ?>"><img src="images/edt.png" width="20" height="16" alt="edit" border="0" /></a> <a href="javascript:freak_del(<?php echo $objItem->id; ?>)" onClick="return confirm('<?php echo $GLOBALS['arrLanguageMessage']['task_delete_confirm']; ?>')" title="<?php echo $GLOBALS['arrLanguageMessage']['task_delete']; ?>"><img src="images/del.png" width="20" height="16" alt="del" border="0" /></a></td>
					</tr>
	<?php
		}
	} else {

// --------------- NO TASK FOUND ---------------------------------------------

	?>
					<tr class="nothanks">
						<td colspan="<?php echo (@constant('FRK_CONTEXT_ENABLE'))?'11':'10'; ?>">
							<p>&nbsp;</p>
							<p align="center">- <?php echo $arrLanguageMessage['no_task_found']; ?> -</p>
							<p align="center"><a href="javascript:freak_new()"><?php echo $arrLanguageMessage['create_task']; ?></a></p>
							<p>&nbsp;</p>
							<p>&nbsp;</p>
						</td>
					</tr>
	<?php
	}
	?>
				</tbody>
			</table>
		</div>
        <div id="fversion"><a href="http://www.taskfreak.com">TaskFreak! single user</a> v0.5 - Released on 2006-01-04 under GNU General Public License</div>
    </div>
  </form>
</body>
</html>
